    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2008, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------
    028     * DefaultValueDataset.java
    029     * ------------------------
    030     * (C) Copyright 2003-2008, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 27-Mar-2003 : Version 1 (DG);
    038     * 18-Aug-2003 : Implemented Cloneable (DG);
    039     * 03-Mar-2005 : Implemented PublicCloneable (DG);
    040     * ------------- JFREECHART 1.0.x ---------------------------------------------
    041     * 30-Jan-2007 : Added explicit super() call in constructor (for clarity) (DG);
    042     *
    043     */
    044
    045    package org.jfree.data.general;
    046
    047    import java.io.Serializable;
    048
    049    import org.jfree.util.ObjectUtilities;
    050    import org.jfree.util.PublicCloneable;
    051
    052    /**
    053     * A dataset that stores a single value (that is possibly <code>null</code>).
    054     * This class provides a default implementation of the {@link ValueDataset}
    055     * interface.
    056     */
    057    public class DefaultValueDataset extends AbstractDataset
    058            implements ValueDataset, Cloneable, PublicCloneable, Serializable {
    059
    060        /** For serialization. */
    061        private static final long serialVersionUID = 8137521217249294891L;
    062
    063        /** The value. */
    064        private Number value;
    065
    066        /**
    067         * Constructs a new dataset, initially empty.
    068         */
    069        public DefaultValueDataset() {
    070            this(null);
    071        }
    072
    073        /**
    074         * Creates a new dataset with the specified value.
    075         *
    076         * @param value  the value.
    077         */
    078        public DefaultValueDataset(double value) {
    079            this(new Double(value));
    080        }
    081
    082        /**
    083         * Creates a new dataset with the specified value.
    084         *
    085         * @param value  the initial value (<code>null</code> permitted).
    086         */
    087        public DefaultValueDataset(Number value) {
    088            super();
    089            this.value = value;
    090        }
    091
    092        /**
    093         * Returns the value.
    094         *
    095         * @return The value (possibly <code>null</code>).
    096         */
    097        public Number getValue() {
    098            return this.value;
    099        }
    100
    101        /**
    102         * Sets the value and sends a {@link DatasetChangeEvent} to all registered
    103         * listeners.
    104         *
    105         * @param value  the new value (<code>null</code> permitted).
    106         */
    107        public void setValue(Number value) {
    108            this.value = value;
    109            notifyListeners(new DatasetChangeEvent(this, this));
    110        }
    111
    112        /**
    113         * Tests this dataset for equality with an arbitrary object.
    114         *
    115         * @param obj  the object (<code>null</code> permitted).
    116         *
    117         * @return A boolean.
    118         */
    119        public boolean equals(Object obj) {
    120            if (obj == this) {
    121                return true;
    122            }
    123            if (obj instanceof ValueDataset) {
    124                ValueDataset vd = (ValueDataset) obj;
    125                return ObjectUtilities.equal(this.value, vd.getValue());
    126            }
    127            return false;
    128        }
    129
    130        /**
    131         * Returns a hash code.
    132         *
    133         * @return A hash code.
    134         */
    135        public int hashCode() {
    136            return (this.value != null ? this.value.hashCode() : 0);
    137        }
    138
    139    }